#!/usr/bin/python

#
# This file is part of "Cut the Crap" (CTC) filtering proxy server.
# Copyright 1999 Constantinos A. Kotsokalis <ckotso@cs.ntua.gr>
#
# CTC is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# CTC is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with CTC; see the file COPYING. If not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
#

import sys, os, signal
import funcs, ctcnet

if __name__ == '__main__':
	if len(sys.argv) > 1:
		# Use args, parse configuration file
		cfg = funcs.get_conf(sys.argv[1])
	else:
		# No configuration file provided, use default settings
		cfg = funcs.get_conf(None)

	# Initialise listening socket
	cfg, inlist = ctcnet.init_socket(cfg)

	# Write PID information for SYSV-like init script
	pid = os.getpid()
	runfile = open("/var/run/ctc.py.pid", "w")
	runfile.write(`pid`)
	runfile.close()

	# Install signal handler for TERM signal
	signal.signal(signal.SIGTERM, funcs.term_handle)

	# Get going.
	ctcnet.loop(cfg, inlist)

